package HomeWork;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Random;
import java.util.Set;

/*
 * Hmo_TT3_Map练习斗地主拿到牌_发牌_并选择地主
 * 	成龙，甄子丹，李连杰三个人打斗地主，三人约定，洗牌后，随机抽取一张"明牌"并夹在中间；然后依次抓牌，谁抓到这张便自动作为地主，并收取最后三张。
	要求：请用程序实现这一过程，最后打印地主名，以及三个人的牌(要求排序)；
	 
	思路：
	  1.定义一个Map集合存储一副扑克牌；List存储编号；
	  2.洗牌；
	  3.随机抽取一个索引(该值必须在倒数三张之前)，用于表示"明牌"，在发牌
	    时谁抓到这一张便作为"地主"；
	  4.依次给三个人(成龙，甄子丹，李连杰)发牌，并监督谁作为地主；地主自
	     动收取最后三张。
	  5.打印地主名；
	  6.最后以排序后的方式打印每个人手里的牌
	  String [] mianZhi = {"2","A","K","Q","J","10","9","8","7","6","5","4","3"};
	  String [] huaSe = {"♠","♥","♣","♦"}	♞♘
 */
public class Hmo_TT3_Map_DDZ {
	public static void main(String[] args) {
		
		// 使用map保存一副牌
		HashMap<Integer, Card> card = initCardMap();
		
		// 新建集合存如map中的key值 下一步打乱list 获取 乱序的map的key
		ArrayList<Integer> list = new ArrayList<>();
		for (int i = 1; i <= 54; i++) {
			list.add(i);
		}
		
		//打乱list 获取 乱序的map的key
		Collections.shuffle(list);

		// 将list中的key分配到每一玩家index
		ArrayList<Integer> player1_index = sendIndexToSmallArrList(list); // list向小集合添加元素 自身在减少元素
		ArrayList<Integer> player2_index = sendIndexToSmallArrList(list); // list向小集合添加元素 自身在减少元素
		ArrayList<Integer> player3_index = sendIndexToSmallArrList(list); // list向小集合添加元素 自身在减少元素
		ArrayList<Integer> diPai_index = new ArrayList<>();
		diPai_index.addAll(list); // 将list剩余的3张牌放入底牌堆中
		
		// 随机获得地主是哪一位
		Random random = new Random();
		int Luckey = random.nextInt(3) + 1;
		switch (Luckey) {
		case 1:
			player1_index.addAll(diPai_index);
			break;
		case 2:
			player2_index.addAll(diPai_index);
			break;
		default:
			player3_index.addAll(diPai_index);
			break;
		}

		// 使用工具将小集合中的index排序
		Collections.sort(player1_index);
		Collections.sort(player2_index);
		Collections.sort(player3_index);

		// 新建集合 保存玩家手牌 在map中查找对应key值得Card 保存到集合中 此处需要有序 因此选择list 或者ArrayList
		ArrayList<Card> player1_card = sendCardInMap(player1_index, card);
		ArrayList<Card> player2_card = sendCardInMap(player2_index, card);
		ArrayList<Card> player3_card = sendCardInMap(player3_index, card);

		// 查看手牌
		showCard(player1_card);
		showCard(player2_card);
		showCard(player3_card);

	}
	
	public static void showCard(ArrayList<Card> player_card) {   //给一个 Crad的集合  将其打印到屏幕上
		for (Card card2 : player_card) {
			System.out.print(card2 + "\t");
		}
		System.out.println();
	}
	//根据indexList中的Key 找到map中对应的card  放入小的集合  作为发牌的动作
	private static ArrayList<Card> sendCardInMap(ArrayList<Integer> indexList, HashMap<Integer, Card> card) {
		ArrayList<Card> list = new ArrayList<>();
		for (Integer key : indexList) {
			list.add(card.get(key));
		}
		return list;
	}
	//将list的集合中前17个元素保存到小的集合中  并将这个小集合返回   就模拟得到了玩家手牌的index
	public static ArrayList<Integer> sendIndexToSmallArrList(ArrayList<Integer> list) {
		ArrayList<Integer> player_index = new ArrayList<>();
		for (int i = 0; i < 17; i++) {
			player_index.add(list.get(0));
			list.remove(0);
		}
		return player_index;
	}
	//将map中的所有牌面打印到控制台  三行 多三张
	public static void ShowMap(HashMap<Integer, Card> card) {
		Set<Entry<Integer, Card>> set = card.entrySet();
		int i = 1;
		for (Entry<Integer, Card> entry : set) {
			System.out.print(entry.getValue() + "\t");
			if (i++ % 17 == 0) {
				System.out.println();
			}
		}
		System.out.println();
	}
	//初始化一组扑克牌 并将其以HashMap<Integer, Card> 返回得到一组牌
	private static HashMap<Integer, Card> initCardMap() {
		HashMap<Integer, Card> cardMap = new HashMap<>();

		cardMap.put(1, new Card("大", "♘"));
		cardMap.put(2, new Card("小", "♞"));
		String[] mianZhi = { "2", "A", "K", "Q", "J", "10", "9", "8", "7", "6", "5", "4", "3" };
		String[] huaSe = { "♠", "♥", "♣", "♦" };
		int a = 3;
		for (int i = 0; i < mianZhi.length; i++) {
			for (int j = 0; j < huaSe.length; j++) {
				cardMap.put(a++, new Card(huaSe[j], mianZhi[i]));
			}
		}
		// System.out.println(cardMap.size());
		return cardMap;
	}
}
